(function () {
    "use strict";

    angular.module('core').controller('unidadeDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'unidadeService', '$alert'];

    function controller($scope, $timeout, $state, $stateParams, unidadeService, $alert) {
        $scope.initializeLayout('Unidade');

        //[Inicializa objetos]
        $scope.state = {
            item: {
                ID: decodeURIComponent($stateParams.id),
            },
            carregando: false,
            vazio: false,
        };


        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.save = function () {
            $scope.state.salvando = true;
            $scope.state.item.CodigoSEFAZ = $scope.state.item.CodigoSEFAZ.Codigo;
            unidadeService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.salvando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.historyBack();
                        }
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };
        $scope.delete = function () {
            $scope.state.salvando = true;
            unidadeService
                .delete({ id: $scope.state.item.ID })
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.salvando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.historyBack();
                        }
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            unidadeService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                            $scope.state.item.CodigoSEFAZ = { Codigo: $scope.state.item.CodigoSEFAZ }
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getAllUnidadeSEFAZ = function () {
            unidadeService
                .getAllUnidadeSEFAZ()
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.unidadeSEFAZ = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAllUnidadeSEFAZ();
            $scope.get();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();